#!/usr/bin/python3

import xml.etree.ElementTree
import urllib.request
import random
import functools

class random_oracle_date:
	def __init__(self, by = 2010, bm = 1, bd = 1):
		self.y = random.randint(by, 2012)
		if self.y > by:
			bm = 1
		self.m = random.randint(bm, 12)
		if (self.y > by) or (self.m == bm):
			bd = 1
		self.d = random.randint(bd, 28) # :3
	def tuple(self):
		return (self.y, self.m, self.d)
	def __str__(self):
		return "to_date('" + str(self.y).zfill(4) + "/" + str(self.m).zfill(2) + "/" + str(self.d).zfill(2) + "', 'yyyy/mm/dd')"

def to_s(x):
	if isinstance(x, str):
		return "'"+str(x)+"'"
	else:
		return str(x)

def print_insert1(table_name, values):
	b = "INSERT INTO " + table_name + " VALUES ("
	l = b
	s = ""
	for i in map(to_s, values):
		if len(l + s + i) <= 80:
			l = l + s + i
		else:
			print(l + s)
			l = len(b)*" " + i
		s = ", "
	print(l+");")

def generate_books(min_count, max_count):
	def add(a, t, y, p):
		c = random.randint(min_count, max_count)
		result.append([len(result), a, t, y, p, c])
	result = []
	add('Г.Гарсия-Молина, Дж. Ульман, Дж. Уидом', 'Системы баз данных', 2004, 'Вильямс')
	add('М. Грабер', 'SQL', 2007, 'Лори')
	add('Э. Спирли', 'Корпоративные хранилища данных. Том 1.Планирование, разработка, реализация', 2001, 'Вильямс')
	add('М. Терьо, Р. Кармайкл, Дж. Вискузи',     '101 Oracle 9i. Администрирование баз данных', 2005, 'Лори')
	add('С.Д. Кузнецов', 'Базы данных : модели и языки', 2008, 'Бином')
	add('Владимир Кириллов, Геннадий Громов', 'Введение в реляционные базы данных', 2009, 'БХВ-Петербург');
	return result

def generate_readers(count):
	assert(count <= 50)
	def mr():
		mr = ["МГУ", "РИА Новости", "Яндекс", "REG.RU", "Badoo Development", "ООО \"Спортвизор\"", "COMDI",
		      "ABBYY", "Microsoft"] 
		return random.choice(mr)
	URL = "http://cadic.name/whoisgen/whoisgen.xml.php?n=" + str(count)
	whois = xml.etree.ElementTree.parse(urllib.request.urlopen(URL))

	result = []
	n = 0
	for e in whois.getroot():
		o,i,f = e.find("rus_name").text.split()
		a = e.find("reg_address").text
		p = e.find("phone").text
		result.append([n, i, f, o, a, p, mr()])
		n += 1
	return result

def generate_requests(count, books, readers):
	def given(b, r):
		return len(list(filter(lambda x: (x[3] == 2) and (x[0] == b) and (x[1] == r), result))) > 0
	result = []
	for n in range(count):
		book = random.randint(0, len(books)-1)
		reader = random.randint(0, len(readers)-1)
		if given(book, reader):
			res = 0
		elif books[book][5] == 0:
			res = 1
		else:
			if random.randint(0, 9) >= 8:
				res = 3
			else:
				res = 2
				books[book][5] -= 1;
		o = [n, book, reader, random_oracle_date(), res]
		result.append(o)
	return result

def generate_letters(requests):
	result = []
	n = 0
	for i in requests:
		request = i[0]
		book = i[1]
		reader = i[2]
		date = random_oracle_date(*i[3].tuple())
		res = i[4]
		if (res == 2) or (res == 3):
			result.append([i[0], book, reader, date])
			n += 1
	return result
		

def print_table(table_name, items):
	print("/*", table_name, "*/")
	for i in items:
		print_insert1(table_name, i)
	print()


books = generate_books(5, 7)
readers = generate_readers(10)
requests = generate_requests(50, books , readers)
letters = generate_letters(requests)

print_table("books", books)
print_table("readers", readers)
print_table("requests", requests)
print_table("letters", letters)
