/*
[1] Значения requests(result):
        0 - книга уже выдана
        1 - книга отсутствует
        2 - требование удовлетворено
        3 - книга вернулась в библиотеку
*/

CREATE TABLE books (
    id           NUMBER         PRIMARY KEY,
    author       VARCHAR2(100),
    title        VARCHAR2(150),
    year         NUMBER,
    publisher    VARCHAR2(100),
    amount       NUMBER         NOT NULL
);

CREATE TABLE readers (
    id           NUMBER         PRIMARY KEY,
    first_name   VARCHAR2(50),
    middle_name  VARCHAR2(50),
    last_name    VARCHAR2(50),
    home_address VARCHAR2(100),
    phone        VARCHAR2(15),
    job          VARCHAR2(100)
);

CREATE TABLE requests (
    id           NUMBER         PRIMARY KEY, /* ??? */

    book_id      NUMBER,
    reader_id    NUMBER,
    date_        DATE           NOT NULL,
    result       NUMBER(1,0)    NOT NULL, /* [1] */
    CONSTRAINT c_requests_book_id   FOREIGN KEY (book_id)   references books (id),
    CONSTRAINT c_requests_reader_id FOREIGN KEY (reader_id) references readers (id),
    CONSTRAINT c_requests_result    CHECK (result BETWEEN 0 AND 3)
);

CREATE TABLE letters (
/*  id           NUMBER         PRIMARY KEY, */
    request_id   NUMBER         PRIMARY KEY, /* ??? */
    book_id      NUMBER,
    reader_id    NUMBER,
    date_        DATE,
    CONSTRAINT c_letters_book_id    FOREIGN KEY (book_id)   references books (id),
    CONSTRAINT c_letters_reader_id  FOREIGN KEY (reader_id) references readers (id),

    CONSTRAINT c_letters_request_id FOREIGN KEY (request_id) references requests (id)
);
