/* 1)Поиск самого читающего читателя. */
SELECT
  q1.reader AS "ID",
  readers.lASt_name AS "Фамилия",
  readers.first_name AS "Имя",
  readers.middle_name AS "Отчество",
  q1.count AS "Количество"
  FROM (SELECT
          max(q1.count) AS m
        FROM (SELECT
                reader_id AS reader,
                count(*) AS count
              FROM letters
              GROUP BY (reader_id)
             ) q1
       ) q2,
       (SELECT
          reader_id AS reader,
          count(*) AS count
        FROM letters
        GROUP BY (reader_id)
       ) q1,
       readers
WHERE q1.count = q2.m AND
      q1.reader = readers.id;

/* 2) Выбор N самых часто запрашимваемых книг, отсутствующих в библиотеке. */
SELECT books.id, books.author, books.title, q1.c
  FROM
    (SELECT book_id AS b, count(*) AS c FROM requests GROUP BY book_id order BY c desc) q1,
    books
  WHERE
    ROWNUM <= 3 /* N */ AND
    q1.b = books.id AND
    books.amount = 0;

/* 3) Поиск M самых читаемых книг. */
SELECT books.id, books.author, books.title, q1.c
  FROM
    (SELECT book_id AS b, count(*) AS c FROM letters GROUP BY book_id order BY c desc) q1,
    books
  WHERE
    ROWNUM <= 3 /* M */ AND
    q1.b = books.id;

/* 4) Поиск читателей, задержавших книги на срок более K дней. */
SELECT
  q1.r AS "ID",
  readers.lASt_name AS "Фамилия",
  readers.first_name AS "Имя",
  readers.middle_name AS "Отчество",
  q1.c AS "Долги"
  FROM
    (SELECT 
      requests.reader_id AS r,
      count(*) AS c
      FROM requests, letters
      WHERE
        letters.request_id = requests.id AND
        requests.result = 2 AND
        letters.date_ > CURRENT_DATE + 200 /* K */
      GROUP BY requests.reader_id
    ) q1,
    readers
  WHERE
    readers.id = q1.r;
